<?php
/*******************************\
**                             **
** Script de Gallerie d'images **
**                             **
\*******************************/



// *** Configuration : Couleurs *** //

//Page :
$c_page_background =	"#b1bbb1"; //Couleur du fond
$c_title_foreground =	"#405050"; //Couleur du titre

//Bloc du haut :
$c_header_background =	"#90a0a0"; //Couleur du fond
$c_header_foreground =	"#555566"; //Couleur du texte
$c_header_border =		"#405050"; //Couleur de la bordure
$s_header_border =		1;         //Epaisseur de la bordure

//Bloc du bas :
$c_footer_background =	"#90a0a0"; //Couleur du fond
$c_footer_foreground =	"#555566"; //Couleur du texte
$c_footer_border =		"#405050"; //Couleur de la bordure
$s_footer_border =		1;         //Epaisseur de la bordure


// *** Configuration : Textes *** //

$title =				"Galerie";
$parent_dir_name =		"R&eacute;pertoire parent";
$current_dir_name =		"R&eacute;pertoire courant : ";


// *** Configuration : Images et Dossiers *** //

$mini_max_w = 	180;		//Largeur max des miniatures
$mini_max_h = 	135;		//Hauteur max des miniatures
$nb_images = 	3;			//Nombre de cases en largeur (3, 5 ou 7)

$list_ignore =	array (".","..");	//Noms des rpertoires qui ne doivent pas tre affichs


// ***  Fin des variables de configuration  *** //
// ***       Ne pas modifier la suite       *** //



// Autres variables


$compteur = 0;
$fullsize = 0;
$minisize = 0;

$flist = 	array();

$l3 = 	547;
$l5 = 	907;
$l7 = 	1267;
$version = "3.1"; //ne pas modifier

// Fonctions

function mininame($name){
   $name2 = substr($name,0,strlen($name)-4);
   $name3 = "___".$name2.".jpg";
   return $name3;
}

function reduce($file, $imgThumbName, $maxWidth, $maxHeight)
{
    $img = ImageCreateFromJpeg($file);
    $imgWidth = imagesx($img);
    $imgHeight = imagesy($img);
    $whFact = $maxWidth/$maxHeight;
    $imgWhFact = $imgWidth/$imgHeight;
    if($whFact < $imgWhFact){
        $thumbWidth  = $maxWidth;
        $thumbHeight = $thumbWidth/$imgWhFact;
    } else {
        $thumbHeight = $maxHeight;
        $thumbWidth = $thumbHeight*$imgWhFact;
    }
    $imgThumb = ImageCreateTruecolor($thumbWidth, $thumbHeight);
    ImageCopyResized($imgThumb, $img, 0, 0, 0, 0, $thumbWidth,
    				$thumbHeight, $imgWidth, $imgHeight);
    $fp = fopen($imgThumbName, "w");
    fclose($fp);
    ImageJpeg($imgThumb, $imgThumbName);
    return $imgThumbName;
}

function list_dir($dir, $list_ignore)
{
	global $c_header_foreground;
	global $flist;
	
	foreach($flist as $file)
	{
		if (is_dir($dir.$file) && !in_array($file, $list_ignore))
		{
			echo '<br><a href="?path='.$dir.$file.'/">';
			echo '<font color="'. $c_header_foreground .'">'.$file.'</font></a>';
		}
	}
}

function prevdir($path)
{
	$ex = explode("/", $path);
	array_pop($ex);
	array_pop($ex);
	return (implode("/", $ex)."/");
}

function aff_path($path)
{
	global $c_header_foreground;
	$lp = "";
	$ex = explode("/", $path);
	array_pop($ex);
	foreach($ex as $d)
	{
		$lp = $lp . $d . '/';
		echo '<a href="'. '?path=' . $lp . '"><font color="' . $c_header_foreground .'">';
		echo $d . '</font></a>' . '/';		
	}
}

// Analyse des variables reues


if (isset($_COOKIE["nb_images"]))
	$nb_images = (int) $_COOKIE["nb_images"];
if ($nb_images != 3 && $nb_images != 5 && $nb_images != 7)
	$nb_images = 3;

if ($nb_images == 3)
	$lc = $l3;
else if ($nb_images == 5)
	$lc = $l5;
else
	$lc = $l7;


if (isset($_REQUEST["path"]))
	$path = $_REQUEST["path"];
else
	$path = "./";

if (strlen($path) < 2 || $path[0] != '.' || $path[1] != '/' || !is_dir($path))
	$path = "./";
	
if (strstr($path, "..") || strstr(urldecode($path), "..") || strstr(rawurldecode($path), ".."))
	$path = "./";


// Analyse du dossier


if (is_dir($path)) {
    if ($dh = opendir($path)) {
        while (($file = readdir($dh)) !== false)
           $flist[] = $file;
        closedir($dh);
        sort($flist);
    }
}

foreach($flist as $file)
{
	if (ereg("jpg",$file) || ereg("JPG",$file) || ereg("jpeg",$file) ||
		ereg("JPEG",$file) || ereg("png",$file) || ereg("PNG",$file))
	{
		if (is_file($path.$file) && substr($file, 0, 3) != "___")
		{
			$tab2[] = $file;
			$compteur++;
		}
	}
}


?>
<html><head>
<style type="text/css">
.box {
	align: center;
	text-align: center;
	width: <?php echo $mini_max_w ?>;
	height : <?php echo $mini_max_h ?>;
	float: right;
	display: inline;
}
.body {
	align: center;
	text-align: center;
	border: 0px;
	margin: 0px;
	padding: 0px;
}
.header {
	align: center;
	text-align: center;
	border: solid <?php echo $s_header_border . 'px ' . $c_header_border ?>;
	background-color: <?php echo $c_header_background ?>;
	margin: 1em;
}
.footer {
	align: center;
	text-align: center;
	border: solid <?php echo $s_footer_border . 'px ' . $c_footer_border ?>;
	background-color: <?php echo $c_footer_background ?>;
	margin: 0px;
}
.title {
	color: <?php echo $c_title_foreground ?>;
	font-size: 2em;
	text-align: left;
	border: 0px;
	margin: 0px;
	padding: 0px;
	text-decoration: none;
}
.tab {
	align: center;
	text-align: center;
	border: 0px;
	margin: 0px;
	padding: 0px;
}
.img {
	vertical-align: top;
}

a.headerlink {
	/*text-decoration:none; */
}
a:hover.headerlink {
	text-decoration:underline;
}
a.footerlink {
	text-decoration:none;
}
a:hover.footerlink {
	text-decoration:underline;
}
</style>
<script language="JavaScript">
function modif_largeur(nb_images)
{
	date=new Date;
	date.setFullYear(date.getFullYear()+10);
	if (nb_images == 3)
	{
		tab.style.width=547;
		EcrireCookie("nb_images", 3, date);
	}

	if (nb_images == 5)
	{
		tab.style.width=907;
		EcrireCookie("nb_images", 5, date);
	}
	if (nb_images == 7)
	{
		tab.style.width=1267;
		EcrireCookie("nb_images", 7, date);
	}
}

//Fonction recuperee d'ecriture dans un cookie
function EcrireCookie(nom, valeur)
{
	var argv=EcrireCookie.arguments;
	var argc=EcrireCookie.arguments.length;
	var expires=(argc > 2) ? argv[2] : null;
	var path=(argc > 3) ? argv[3] : null;
	var domain=(argc > 4) ? argv[4] : null;
	var secure=(argc > 5) ? argv[5] : false;
	document.cookie=nom+"="+escape(valeur)+
	((expires==null) ? "" : ("; expires="+expires.toGMTString()))+
	((path==null) ? "" : ("; path="+path))+
	((domain==null) ? "" : ("; domain="+domain))+
	((secure==true) ? "; secure" : "");
}
</script>
<title><?php echo $title ?></title>
</head>

<body bgcolor="<?php echo $c_page_background ?>" class="body">

<center>
<table ID=tab class="tab" width=<?php echo $lc ?>>

<!-- Titre -->
<tr><td style="height: 55px;" class="title">
<?php echo $title ?>
</td></tr>

<!-- En-Tte -->
<tr><td class=header>
      <table style="text-align: left; width: 100%;" border="0" cellpadding="9" cellspacing="2">
        <tbody>
          <tr>
            <td style="vertical-align: top;"><font color="<?php echo $c_header_foreground ?>"><?php echo $current_dir_name;
            aff_path($path); ?></font>
            <br>

            <?php

            if ($path != "./")
            {
            	echo '<br><a href="?path='. prevdir($path);
            	echo '"><font color="'.$c_header_foreground.'">' . $parent_dir_name . '</font></a>';
            }
			list_dir($path, $list_ignore); 
            
           ?> 
            </td>
            <td style="text-align: center; vertical-align: middle; height: 65px; width: 35px;">
            <a href="javascript:modif_largeur(3)">
            <font color="<?php echo $c_header_foreground ?>">3</font></a><br>
            <a href="javascript:modif_largeur(5)">
            <font color="<?php echo $c_header_foreground ?>">5</font></a><br>
            <a href="javascript:modif_largeur(7)">
            <font color="<?php echo $c_header_foreground ?>">7</font></a></td>
          </tr>
        </tbody>
      </table>
</td></tr>

<!-- Saut -->
<?php if ($compteur) { ?>
<tr><td style="height: 10px;">
</td></tr>
<?php } ?>

<!-- Images -->
<tr><td>
<?php

if(isset($tab2))
{
	$compteur = 0;
	foreach($tab2 as $file)
	{

		$file2 = mininame($file);
	    $path2 = $path.$file;
		$path_mini = $path.$file2;
		if(!file_exists($path_mini))
			reduce($path2, $path_mini, $mini_max_w, $mini_max_h);
		$fullsize += filesize($path2);
		$minisize += filesize($path_mini);
		$bouh = "\n	<a href=\"$path2\">\n		<img src=\"$path_mini\" border=\"0\" alt=\"$file\">\n	</a>";
   		$compteur++;

		if ($compteur != 1)
			echo "\n".'<div class="box">'. "\n</div>\n";
		echo "\n".'<div class="box">'.$bouh."\n</div>\n";
	}
}

?>

</td></tr>

<!-- Saut 2 -->
<?php if ($compteur) { ?>
<tr><td style="height: 10px;">
</td></tr>
<?php } ?>

<!-- Pied de Page -->
<tr><td class=footer>
<font size=2 color="<?php echo $c_footer_foreground ?>">
<?php
if ($compteur) {
	echo "Full: ".round($fullsize / (1024 * 1024))."Mo ";
	echo " &nbsp; Mini: ". round($minisize / 1024)."Ko ";
	echo " &nbsp; Images: ". $compteur . "<br>";
}
?>
<a href="http://jonathan494.free.fr/AzaView/" class=footerlink><font color="<?php echo $c_header_foreground ?>">Galerie gnre par AzaView <?php echo $version ?></font></a> :: <a href="http://jonathan494.free.fr/AzaView/?p=ver&version=<?php echo $version ?>" class=footerlink><font color="<?php echo $c_header_foreground ?>">Recherche de mise  jour</font></a>
</font>
</td></tr>

</table>
</body></html>